/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#ifndef __CPU_INFO_H__
#define __CPU_INFO_H__

#ifdef _WIN32

#include <windows.h>

#else

#define ULONG	unsigned long
#define DWORD	unsigned long
#define BOOL	int
#define BYTE	unsigned char
#define WORD	unsigned short

#define TRUE	1
#define FALSE	0

#endif

// 莞 = NxԂɂȂ̂ŗv
#define SLEEP_TIME 500

class CCpuInfo  
{
public:
	CCpuInfo(
#ifdef _WIN32
		DWORD mask
#endif
		);
	~CCpuInfo();

	char* GetInfo( DWORD ID , char* pStr );
	int GetString( DWORD ID , char* pStr );
	int GetData( DWORD ID , DWORD* pData );
	int SetData( DWORD ID , DWORD Data );
	void Init(					// Init Class CpuInfo
#ifdef _WIN32
		DWORD mask
#endif
		);

protected:
	int FillCpuInfo();			// CPU ̏ݒ肷
	void InitData();			// NX̕ϐ

	int CheckEnableCPUID(void);	// CPUID/RDTSC ߂p\ǂ𒲂ׂ
	double CheckClock();		// NbNg̑(Query Performance Counter)
	int  SetUpRDMSR();			// WinIOMSR ǂݍ CPU  FSB/Multiplier ݒ肷			
	void SetCPUFSB();			// FSB/Multiplier ̐ݒ
	void FillNameString();		// NameString ̐ݒ Max=48
	int FillCacheInfo();		// Cache ̏ݒ肷
	void FillCacheInfoIntel();	// Cache ̏ݒ肷 <INTEL>
	void CacheInfoIntel(int);	// Cache ̏ݒ肷 <FillCacheInfoIntel ̉>
	void FillCacheInfoAMD();	// Cache ̏ݒ肷 <AMD>
	void SetCPUName();			// CPUName ̐ݒ
	void SetCPUNameIntel();		// CPUName ̐ݒ <INTEL>
	void SetCPUNameAMD();		// CPUName ̐ݒ <AMD>
	void SetCPUNameTMx86();		// CPUName ̐ݒ <Transmeta>
	void SetCPUNameVIA();		// CPUName ̐ݒ <VIA>
	void SetCPUNameOthers();	// CPUName ̐ݒ <̑>
	void FillTMx86Ex();			// Transmeta p
	int SetCacheSpeed();		// L2 Cache Speed Info
	int CheckAMDMobile();		// AMD Mobile CPU Check

	int FlagQPC;				// Query Performance Counter p\ǂH
	int FlagCPUID;				// CPUID ߂p\ǂH
	int FlagRDTSC;				// RDTSC ߂p\ǂH
	int FlagRDMSR;				// RDMSR ߂p\ǂH
	int FlagBrand;				// Intel AMD etc..
	int FlagMultiTable;			// Multiplier Table 
	int FlagHalfSpeedCache;		// L2 Cache Speed for Intel
	int FlagAMDMobile;			// AMD Mobile CPU
	int MaxCPUID;				// W ̍őLl
	DWORD MaxCPUIDEx;			// g 0x80000000 ȍ~̍őLl
	DWORD MsrEAX1;
	DWORD MsrEAX2;
	DWORD MsrEDX1;
	DWORD MsrEDX2;

#ifdef _WIN32
	DWORD m_mask;				// Processor Mask for Win32
#endif

protected:

// GetString or GetData

	// String //
	char		NameSysInfo[65];
	char		FSBMode[4];					// ""=SDR "DDR" "QDR"
	char		VendorString[13];			// OriginalVendorString
	char		VendorName[13];				// VendorName
	char		NameString[49];
	char		PlatformName[65];
	char		TypeName[33];
	char		FMS[4];
	char		CacheSpeedS[9];
	char		Name[65];
	char		CodeName[65];
	char		FullName[65];
	char		ProcessRule[65];

// dobule //
	double		Clock;
	double		SystemClock;
	double		SystemBus;
	double		Multiplier;
	double		ClockOri;
	double		SystemClockOri;
	double		SystemBusOri;
	double		CacheSpeed;
	double		OverClock;
	double		MultiplierOri;

// integer //
	int			Number;
	int			Family;
	int			Model;
	int			Stepping;
	int			FamilyEx;
	int			ModelEx;
	int			BrandID;
	int			Apic;
	int			CacheL1I;
	int			CacheL1T;
	int			CacheL1U;
	int			CacheL1D;
	int			CacheL2;
	int			CacheL3;
	int			HyperThreadNum;
	int			Type;
	int			FSBMultiplier;
	int			PlatformID;
	int			PhysicalNumber;

	char		L1ITUWaysS[8];
	char		L1ITULinesS[8];
	char		L1DWaysS[8];
	char		L1DLinesS[8];
	char		L2WaysS[8];
	char		L2LinesS[8];
	char		L3WaysS[8];
	char		L3LinesS[8];

	int			L1ITUWays;
	int			L1ITULines;
	int			L1DWays;
	int			L1DLines;
	int			L2Ways;
	int			L2Lines;
	int			L3Ways;
	int			L3Lines;

	DWORD		Feature;
	DWORD		FeatureEcx;
	DWORD		FeatureEx;
	DWORD		Version;
	DWORD		VersionEx;

// flag //
	int			FlagMMX;
	int			FlagMMXEx;
	int			FlagSSE;
	int			FlagSSE2;
	int			FlagSSE3;
	int			Flag3DNow;
	int			Flag3DNowEx;
	int			FlagHT;
	int			FlagAA64;
	int			FlagIA64;
	int			FlagClockModulation;

	// for Transmeta // 
	char		TmNameString[65];
	double		TmClock;
	double		TmNominalClock;

// Love Hammer
	DWORD		FlagLoveHammer; /* 7 = K7, 8 = K8 */
	DWORD		LhCurrentFID;
	DWORD		LhCurrentVID;
	DWORD		LhStartupFID;
	DWORD		LhStartupVID;
	DWORD		LhMaxFID;
	DWORD		LhMaxVID;
	char		LhCurrentMultiplier[16];
	char		LhStartupMultiplier[16];
	char		LhMaxMultiplier[16];
	char		LhCurrentVoltage[16];
	char		LhStartupVoltage[16];
	char		LhMaxVoltage[16];
};

#endif // __CPU_INFO_H__
