////////////////////////////////////////////////////////
//
//  Based on pcidebug.dll & pcidegug.sys
//                        Aug 20 1999 kashiwano masahiro
//
////////////////////////////////////////////////////////

#include <ntddk.h>
//#include <devioctl.h>

#define MSR_TYPE 40000

#define IOCTL_READ_MSR \
	CTL_CODE(MSR_TYPE, 0x981, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_WRITE_MSR \
	CTL_CODE(MSR_TYPE, 0x982, METHOD_BUFFERED, FILE_ANY_ACCESS)

// NT device name
#define MSR_DEVICE_NAME L"\\Device\\CrystalCpuInfo"
#define DOS_DEVICE_NAME L"\\DosDevices\\CrystalCpuInfo"

#define N_ISR	16

// driver local data structure specific to each device object
typedef struct _LOCAL_DEVICE_INFO {
	ULONG				DeviceType;		// Our private Device Type
	PDEVICE_OBJECT		DeviceObject;	// The Gpd device object.
	struct {
		PKINTERRUPT	InterruptObject;
		BOOLEAN				SetupOK;	// after call setup interrupt set TRUE
		KAFFINITY			Affinity;
		KIRQL				irql;
		ULONG				MappedVector;
		KINTERRUPT_MODE		InterruptMode;
		BOOLEAN				ShareVector;

		HANDLE Handle;
		PKEVENT Event;
	} table[N_ISR];
} LOCAL_DEVICE_INFO, *PLOCAL_DEVICE_INFO;

/********************* function prototypes ***********************************/
//

NTSTATUS	DriverEntry(
				IN PDRIVER_OBJECT DriverObject,
				IN PUNICODE_STRING RegistryPath
			);

NTSTATUS	CreateDevice(
				IN PWSTR szPrototypeName,
				IN DEVICE_TYPE DeviceType,
				IN PDRIVER_OBJECT DriverObject,
				OUT PDEVICE_OBJECT *ppDevObj
			);

NTSTATUS	Dispatch(
				IN PDEVICE_OBJECT pDO,
				IN PIRP pIrp
			);

VOID		Unload(
				IN PDRIVER_OBJECT DriverObject
			);

NTSTATUS	ReadMSR(
				ULONG IoctlCode,
				void *lpInBuffer, 
				ULONG nInBufferSize, 
				void *lpOutBuffer, 
				ULONG nOutBufferSize, 
				ULONG *lpBytesReturned
			);

NTSTATUS	WriteMSR(
				ULONG IoctlCode,
				void *lpInBuffer, 
				ULONG nInBufferSize, 
				void *lpOutBuffer, 
				ULONG nOutBufferSize, 
				ULONG *lpBytesReturned
			);
