/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "CpuidDlg.h"
#include "../common/GetFileVersion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static void GetCPUID(DWORD id,DWORD* A,DWORD* B,DWORD* C,DWORD* D);

/////////////////////////////////////////////////////////////////////////////
// CCpuidDlg _CAO


CCpuidDlg::CCpuidDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCpuidDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCpuidDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_count = 0;
}


void CCpuidDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCpuidDlg)
	DDX_Control(pDX, IDC_CPUID_LIST, m_CpuidList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCpuidDlg, CDialog)
	//{{AFX_MSG_MAP(CCpuidDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCpuidDlg bZ[W nh

void CCpuidDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CCpuidDlg::OnOK() 
{
	CDialog::OnOK();
}

BOOL CCpuidDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), TRUE);
	
// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;
	// Rg[̕擾
	CRect cr;
	m_CpuidList.GetClientRect(cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 470 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_CpuidList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_CpuidList.m_hWnd, dwStyle);
	}
	if( comctl32 >= 471 ){
		m_CpuidList.GetHeaderCtrl()->EnableWindow(FALSE);
	}

	while(m_CpuidList.DeleteColumn(0)){}
	m_CpuidList.DeleteAllItems();
	m_CpuidList.InsertColumn(0,"CPUID",LVCFMT_CENTER,width / 5,0);
	m_CpuidList.InsertColumn(1,"EAX",LVCFMT_LEFT,width / 5,0);
	m_CpuidList.InsertColumn(2,"EBX",LVCFMT_LEFT,width / 5,0);
	m_CpuidList.InsertColumn(3,"ECX",LVCFMT_LEFT,width / 5,0);
	m_CpuidList.InsertColumn(4,"EDX",LVCFMT_LEFT,width / 5,0);

	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;

	CString cstr;
	DWORD i=0x00;
	DWORD dwEAX,dwEBX,dwECX,dwEDX;

	GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	DWORD MaxCPUID = dwEAX;
	InsertCpuidInfo(i,dwEAX,dwEBX,dwECX,dwEDX);
	for(i=1;i<=MaxCPUID;i++){
		GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
		InsertCpuidInfo(i,dwEAX,dwEBX,dwECX,dwEDX);
	}

	GetCPUID(0x80000000,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	if(dwEAX > 0x80000000){
		DWORD MaxCPUIDEx = dwEAX;
		for(i=0x80000000;i<=MaxCPUIDEx;i++){
			GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
			InsertCpuidInfo(i,dwEAX,dwEBX,dwECX,dwEDX);
		}
	}

	GetCPUID(0x80860000,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	if(dwEAX > 0x80000000){
		DWORD MaxCPUIDTx = dwEAX;
		for(i=0x80860000;i<=MaxCPUIDTx;i++){
			GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
			InsertCpuidInfo(i,dwEAX,dwEBX,dwECX,dwEDX);
		}
	}
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CPUID Xgɒǉ

void CCpuidDlg::InsertCpuidInfo(DWORD id,DWORD A,DWORD B,DWORD C,DWORD D)
{
	CString str;
	str.Format("0x%08X",id);	m_CpuidList.InsertItem(m_count,str);
	str.Format("0x%08X",A);		m_CpuidList.SetItemText(m_count,1,str);
	str.Format("0x%08X",B);		m_CpuidList.SetItemText(m_count,2,str);
	str.Format("0x%08X",C);		m_CpuidList.SetItemText(m_count,3,str);
	str.Format("0x%08X",D);		m_CpuidList.SetItemText(m_count,4,str);
	m_count++;
}

/////////////////////////////////////////////////////////////////////////////
// CPUID ߂̎s

static void GetCPUID(DWORD id,DWORD* A,DWORD* B,DWORD* C,DWORD* D)
{
	DWORD dwEAX,dwEBX,dwECX,dwEDX;
	_asm{
		mov eax,id
		cpuid
		mov dwEAX , eax
		mov dwEBX , ebx	
		mov dwECX , ecx
		mov dwEDX , edx
	}
	*A = dwEAX;
	*B = dwEBX;
	*C = dwECX;
	*D = dwEDX;
}
